import { applyOptionsMiddleware } from "./../middleware";
import setTemplate from "./setTemplate";
import setStyles from "./setStyles";

export default (function (options) {
  return function (original) {
    var cb = original.prototype.connectedCallback;
    original.prototype.connectedCallback = function () {
      var target = this;
      if (options.shadowDOM === true) {
        var shadowRoot = target.shadowRoot;
        if (!shadowRoot) {
          shadowRoot = target.attachShadow({
            mode: options.mode ? options.mode : "open"
          });
        }
        target = shadowRoot;
      }

      applyOptionsMiddleware(setTemplate, setStyles)(target)(options);

      var oAttr = original.observedAttributes;
      if (oAttr && oAttr.indexOf(name) > -1) {
        this["_" + name] = this.getAttribute(name);
      }

      if (cb) {
        cb.call(this);
      }
    };

    return original;
  };
});