import { applyMiddleware } from "./middleware";
import connectedCallback from "./connectedCallback";
import attributeChangedCallback from "./attributeChangedCallback";
import proxy from "./proxy";

export function WebComponent(name) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return function (target) {
    target = applyMiddleware(connectedCallback(options), attributeChangedCallback, proxy)(target);

    return customElements.define(name, target, {
      "extends": options["extends"]
    });
  };
}