"use strict";

exports.__esModule = true;

var _middleware = require("./../middleware");

var _setTemplate = require("./setTemplate");

var _setTemplate2 = _interopRequireDefault(_setTemplate);

var _setStyles = require("./setStyles");

var _setStyles2 = _interopRequireDefault(_setStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

exports["default"] = function (options) {
  return function (original) {
    var cb = original.prototype.connectedCallback;
    original.prototype.connectedCallback = function () {
      var target = this;
      if (options.shadowDOM === true) {
        var shadowRoot = target.shadowRoot;
        if (!shadowRoot) {
          shadowRoot = target.attachShadow({
            mode: options.mode ? options.mode : "open"
          });
        }
        target = shadowRoot;
      }

      (0, _middleware.applyOptionsMiddleware)(_setTemplate2["default"], _setStyles2["default"])(target)(options);

      var oAttr = original.observedAttributes;
      if (oAttr && oAttr.indexOf(name) > -1) {
        this["_" + name] = this.getAttribute(name);
      }

      if (cb) {
        cb.call(this);
      }
    };

    return original;
  };
};